#!/usr/local/bin/perl
use Socket;

$home = "your_home_directory";
$useraddress = "username\@userhost";

$sock_addr = 'S n a4 x8';
$hostname = '$ENV{HOST}';
($name,$aliases,$proto) = getprotobyname('tcp');
$portnum = 80;

($name,$aliases,$type,$len,$thisaddr) = gethostbyname($hostname);
$client_addr = pack($sock_addr,&AF_INET,0,$thisaddr);
$STDFORMAT = "5 4 3 6 7";
$HINAFORMAT = "3 4 5 6 7";
$OPTlast = 0;

open(LOG,"$home/.DiaryCheckLog");
while(<LOG>){
    chop;
    ($url,$time) = split('%%');
    $timedb{$url} = $time;
}
close(LOG);

open(RESULT,">$home/.DiaryCheckResult.html");
open(LOG,">$home/.DiaryCheckLog");
open(COM,"$home/.DiaryCheckrc");
while(<COM>){
    if(/^ANTENNA/)   {&ANTENNA();}
    elsif(/^KEYWORD(?:\[(.*?)\])?(.)/){&KEYWORD($1,$2);}
    elsif(/^GET(?:\[(.*?)\])?/)       {&GET($1);}
    elsif(/^HEAD(?:\[(.*?)\])?/)      {&HEAD($1);}
}

sub ANTENNA{
    /ANTENNA http:\/\/(.*?)(\/.*\/)(.*)/;
    $method = "GET";
    $mode = "ANTENNA";
    $servname = $1;
    $point = "$2$3";
    $delword = "";
    $count = 0;
    $format = $HINAFORMAT;
    $url = "http://${servname}${point}";
    while(<COM>){
	if(/^ENDANTENNA/){
	    last;
	}else{
	    chop;
	    $url[$count++] = $_;
	}
    }
    &MakeConnect($servname);
    &SendRequest11($method,$servname,$point);
    while(<S>){
	for($i=0;$i<$count;$i++){
	   if(/$url[$i]/){
	       $time[$i] = $_;
	   }
       }
    }
    close(S);
    for($i=0;$i<$count;$i++){printcheckresult($url[$i],$time[$i]);}
}

sub KEYWORD{
    local($option,$quote) = @_;
    &checkoption($option);
    /^KEYWORD(?:\[.*\])?$quote(.*?)$quote(?:(.*?)$quote)?\s*(.*)/;
    $method = "GET";
    $keyword = $1;
    $delword = $2;
    $args = $3;
    $args =~ /http:\/\/(.*?)(\/\S*)(?:[$ ](.*))?/;
    $servname = $1;
    $point = "$2";
    $format = $3;
    if($format eq ""){$format = $STDFORMAT;}
    &GetData();
}

sub GET{
    local($option) = @_;
    &checkoption($option);
    /^GET(?:\[.*\])?\s+(.*)/;
    $method = "GET";
    $keyword = "Last-Modified:";
    undef($delword);
    $args = $1; 
    $args =~/http:\/\/(.*?)(\/\S*)(\s+.*?)*/;
    $servname = $1;
    $point = "$2";
    $format = $4;
    if($format eq ""){$format = $STDFORMAT;}
    &GetData();
}

sub HEAD{
    local($option) = @_;
    &checkoption($option);
    /^HEAD(?:\[.*\])?\s+(.*)/;
    $method = "HEAD";
    $keyword = "Last-Modified:";
    undef($delword);
    $args = $1;
    $args =~/http:\/\/(.*?)(\/\S*)(\s+.*?)*/;
    $servname = $1;
    $point = "$2";
    $format = $4;
    if($format eq ""){$format = $STDFORMAT;}
    &GetData();
}

sub MakeConnect{
    local($servname) = @_;
    ($name,$aliases,$portnum)
	= getservbyname($portnum,'tcp') unless $portnum =~/^\d+$/;;
    ($name,$aliases,$type,$len,$thataddr) = gethostbyname($servname);
    $serv_addr = pack($sock_addr,&AF_INET,80,$thataddr);
    
    socket(S,&PF_INET,&SOCK_STREAM,$proto)||return "cannot get a socket";
    bind(S,$client_addr) ||return "cannot bind socket";
    connect(S,$serv_addr) ||return "cannot connect socket";
    select(S);
    $| = 1;
    select(STDOUT);
    return 0;
}

sub SendRequest10{
    local($method,$point) = @_;
    print S "$method $point HTTP/1.0\r\n";
    print S "User-Agent: DiaryCheck.pl/0.5b\r\n";
    print S "From: $useraddress\r\n";
    print S "\r\n";
}

sub SendRequest11{
    local($method,$servname,$point) = @_;
    print S "$method $point HTTP/1.1\r\n";
    print S "User-Agent: DiaryCheck.pl/0.5b\r\n";
    print S "From: $useraddress\r\n";
    print S "Host: $servname\r\n";
    print S "\r\n";
}

sub GetData{
    $url = "http://${servname}${point}";
    if(($state = &MakeConnect($servname)) ne "0"){
	print "$url:$state\n";
	print RESULT "$state($timedb{$url}) ; <a href='${url}' target='diarycheck'>$url</a><br>\n";
	print LOG "$url%%$timedb{$url}\n";
	next;
    }
    &SendRequest10($method,$point);
#   &SendRequest11($method,$servname,$point);
    while(<S>){
	if(/($keyword\s*.*)/i){
	    $time = $1;
	    if($OPTlast == 0){
		while(<S>){
		}
		
	    }
	}
    }
    &printcheckresult($url,$time);
    close(S);
}

sub printcheckresult{
    local($url,$_) = @_;
    local($time);
    s/Jan/01/;
    s/Feb/02/;
    s/Mar/03/;
    s/Apr/04/;
    s/May/05/;
    s/Jun/06/;
    s/Jul/07/;
    s/Aug/08/;
    s/Sep/09/;
    s/Oct/10/;
    s/Nov/11/;
    s/Dec/12/;

    undef(@timeval);
    @timeval = split(/[ ,\-:\/\.<>]+/);
    $NA = push(@timeval,('--'))-1;
    $format =~ s/\%/$NA/g;
    @formatval = split(/ /,$format);
    $year = $timeval[$formatval[0]];
    $month = $timeval[$formatval[1]];
    $day = $timeval[$formatval[2]];
    $hour = $timeval[$formatval[3]];
    $minute = $timeval[$formatval[4]];
    if(/GMT/){
	$hour += 9;
	if($hour > 24){
	    $day +=1;
	    $hour -= 24;
	}
    }
    $time = "$year/$month/$day $hour:$minute";

    if($time ne $timedb{$url}){print RESULT "+ ";}
    print RESULT "$time ; <a href='${url}' target='diarycheck'>$url</a><br>\n";
    print "${url}\n$_\n" if ($OPTverbose == 1);
    print LOG "$url%%$time\n";
}

sub checkoption{
    local($option) = @_;
    $OPTlast = 0;$OPTverbose = 0;
    if($option =~ /l/){
	$OPTlast = 1;
    }
    if($option =~ /v/){
	$OPTverbose = 1;
    }
}
